<?php defined('SYSPATH') or die('No direct script access.');

class Model_Rating extends Model
{
    public function GetStudentsForRating($disciplineID) {
        $sql = "CALL `GetStudentsForRating`('$disciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    /**
     * Get the disciplines's roadmap (учебная карта).
     * @param $discipline int discipline id
     * @return Database_Result select from <tt>view_roadmap</tt> table
     */
    public function getMapForDiscipline($discipline) {
        $sql = "CALL `GetRoadmap`('$discipline'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    /**
     * @param $discipline int discipline id
     * @param $student int student id
     * @return Database_Result
     */
    public static function getRates($discipline, $student) {
        $sql = "CALL `GetRates`('$student', '$discipline'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    /**
     * @param $discipline int discipline id
     * @param $student int student id
     * @return Database_Result
     */
    public static function getExamRates($discipline, $student) {
        $sql = "CALL `GetRatesExam`('$student', '$discipline'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function GetMapForDisciplineExam($disciplineID) {
        $sql = "CALL `GetRoadmapExam`('$disciplineID'); ";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function SetStudentRate($teacherID, $studentID, $submoduleID, $rate) {
        $sql = "SELECT `SetStudentRate`('$teacherID', '$studentID', '$submoduleID', '$rate') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function GetStudentRate($studentID, $disciplineID) {
        $sql = "SELECT `GetRateForDisc`('$studentID', '$disciplineID') AS `Num`;";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function getRatesForStudentsGroup($disciplineID, $groupID) {
        $sql = "CALL `GetRatesForGroup`('$disciplineID', '$groupID')";
        return DB::query(Database::SELECT, $sql)->execute();
    }

    public function getFinalFormInfo($disciplineID, $groupID) {
        $sql = "CALL `getFinalFormInfo`('$disciplineID', '$groupID')";
        return DB::query(Database::SELECT, $sql)->execute();
    }
}
